/// Interface for a class that iterates over a sequence of strings.
abstract class StringSequence {
  /// Returns the next string in this sequence.
  String next();
}

/// A delegating [StringSequence] implementation.
class StringSequenceTransformer implements StringSequence {
  final StringSequence _delegate;

  StringSequenceTransformer(this._delegate);

  @override
  String next() => _delegate.next();
}
