import 'package:string_sequence/common_alphabets.dart';
import 'package:test/test.dart';

void main() {
  group('$EnglishAlphabet', () {
    test('successor(end) should return null.', () {
      var alphabet = new EnglishAlphabet();
      expect(alphabet.successor(alphabet.end), isNull);

      alphabet = new EnglishAlphabet.uppercase();
      expect(alphabet.successor(alphabet.end), isNull);
    });

    test('predecessor(start) should return null.', () {
      var alphabet = new EnglishAlphabet();
      expect(alphabet.predecessor(alphabet.start), isNull);

      alphabet = new EnglishAlphabet.uppercase();
      expect(alphabet.predecessor(alphabet.start), isNull);
    });

    test('successor should return the successive letters of the alphabet.', () {
      var alphabet = new EnglishAlphabet();
      var symbol = alphabet.start;

      expect(symbol, 'a');
      expect((symbol = alphabet.successor(symbol)), 'b');
      expect((symbol = alphabet.successor(symbol)), 'c');
      expect((symbol = alphabet.successor(symbol)), 'd');
      expect((symbol = alphabet.successor(symbol)), 'e');
      expect((symbol = alphabet.successor(symbol)), 'f');
      expect((symbol = alphabet.successor(symbol)), 'g');
      expect((symbol = alphabet.successor(symbol)), 'h');
      expect((symbol = alphabet.successor(symbol)), 'i');
      expect((symbol = alphabet.successor(symbol)), 'j');
      expect((symbol = alphabet.successor(symbol)), 'k');
      expect((symbol = alphabet.successor(symbol)), 'l');
      expect((symbol = alphabet.successor(symbol)), 'm');
      expect((symbol = alphabet.successor(symbol)), 'n');
      expect((symbol = alphabet.successor(symbol)), 'o');
      expect((symbol = alphabet.successor(symbol)), 'p');
      expect((symbol = alphabet.successor(symbol)), 'q');
      expect((symbol = alphabet.successor(symbol)), 'r');
      expect((symbol = alphabet.successor(symbol)), 's');
      expect((symbol = alphabet.successor(symbol)), 't');
      expect((symbol = alphabet.successor(symbol)), 'u');
      expect((symbol = alphabet.successor(symbol)), 'v');
      expect((symbol = alphabet.successor(symbol)), 'w');
      expect((symbol = alphabet.successor(symbol)), 'x');
      expect((symbol = alphabet.successor(symbol)), 'y');
      expect((symbol = alphabet.successor(symbol)), 'z');

      alphabet = new EnglishAlphabet.uppercase();
      symbol = alphabet.start;

      expect(symbol, 'A');
      expect((symbol = alphabet.successor(symbol)), 'B');
      expect((symbol = alphabet.successor(symbol)), 'C');
      expect((symbol = alphabet.successor(symbol)), 'D');
      expect((symbol = alphabet.successor(symbol)), 'E');
      expect((symbol = alphabet.successor(symbol)), 'F');
      expect((symbol = alphabet.successor(symbol)), 'G');
      expect((symbol = alphabet.successor(symbol)), 'H');
      expect((symbol = alphabet.successor(symbol)), 'I');
      expect((symbol = alphabet.successor(symbol)), 'J');
      expect((symbol = alphabet.successor(symbol)), 'K');
      expect((symbol = alphabet.successor(symbol)), 'L');
      expect((symbol = alphabet.successor(symbol)), 'M');
      expect((symbol = alphabet.successor(symbol)), 'N');
      expect((symbol = alphabet.successor(symbol)), 'O');
      expect((symbol = alphabet.successor(symbol)), 'P');
      expect((symbol = alphabet.successor(symbol)), 'Q');
      expect((symbol = alphabet.successor(symbol)), 'R');
      expect((symbol = alphabet.successor(symbol)), 'S');
      expect((symbol = alphabet.successor(symbol)), 'T');
      expect((symbol = alphabet.successor(symbol)), 'U');
      expect((symbol = alphabet.successor(symbol)), 'V');
      expect((symbol = alphabet.successor(symbol)), 'W');
      expect((symbol = alphabet.successor(symbol)), 'X');
      expect((symbol = alphabet.successor(symbol)), 'Y');
      expect((symbol = alphabet.successor(symbol)), 'Z');
    });

    test('predecessor should return the predecessive letters of the alphabet',
        () {
      var alphabet = new EnglishAlphabet();
      var symbol = alphabet.end;

      expect(symbol, 'z');
      expect((symbol = alphabet.predecessor(symbol)), 'y');
      expect((symbol = alphabet.predecessor(symbol)), 'x');
      expect((symbol = alphabet.predecessor(symbol)), 'w');
      expect((symbol = alphabet.predecessor(symbol)), 'v');
      expect((symbol = alphabet.predecessor(symbol)), 'u');
      expect((symbol = alphabet.predecessor(symbol)), 't');
      expect((symbol = alphabet.predecessor(symbol)), 's');
      expect((symbol = alphabet.predecessor(symbol)), 'r');
      expect((symbol = alphabet.predecessor(symbol)), 'q');
      expect((symbol = alphabet.predecessor(symbol)), 'p');
      expect((symbol = alphabet.predecessor(symbol)), 'o');
      expect((symbol = alphabet.predecessor(symbol)), 'n');
      expect((symbol = alphabet.predecessor(symbol)), 'm');
      expect((symbol = alphabet.predecessor(symbol)), 'l');
      expect((symbol = alphabet.predecessor(symbol)), 'k');
      expect((symbol = alphabet.predecessor(symbol)), 'j');
      expect((symbol = alphabet.predecessor(symbol)), 'i');
      expect((symbol = alphabet.predecessor(symbol)), 'h');
      expect((symbol = alphabet.predecessor(symbol)), 'g');
      expect((symbol = alphabet.predecessor(symbol)), 'f');
      expect((symbol = alphabet.predecessor(symbol)), 'e');
      expect((symbol = alphabet.predecessor(symbol)), 'd');
      expect((symbol = alphabet.predecessor(symbol)), 'c');
      expect((symbol = alphabet.predecessor(symbol)), 'b');
      expect((symbol = alphabet.predecessor(symbol)), 'a');

      alphabet = new EnglishAlphabet.uppercase();
      symbol = alphabet.end;

      expect(symbol, 'Z');
      expect((symbol = alphabet.predecessor(symbol)), 'Y');
      expect((symbol = alphabet.predecessor(symbol)), 'X');
      expect((symbol = alphabet.predecessor(symbol)), 'W');
      expect((symbol = alphabet.predecessor(symbol)), 'V');
      expect((symbol = alphabet.predecessor(symbol)), 'U');
      expect((symbol = alphabet.predecessor(symbol)), 'T');
      expect((symbol = alphabet.predecessor(symbol)), 'S');
      expect((symbol = alphabet.predecessor(symbol)), 'R');
      expect((symbol = alphabet.predecessor(symbol)), 'Q');
      expect((symbol = alphabet.predecessor(symbol)), 'P');
      expect((symbol = alphabet.predecessor(symbol)), 'O');
      expect((symbol = alphabet.predecessor(symbol)), 'N');
      expect((symbol = alphabet.predecessor(symbol)), 'M');
      expect((symbol = alphabet.predecessor(symbol)), 'L');
      expect((symbol = alphabet.predecessor(symbol)), 'K');
      expect((symbol = alphabet.predecessor(symbol)), 'J');
      expect((symbol = alphabet.predecessor(symbol)), 'I');
      expect((symbol = alphabet.predecessor(symbol)), 'H');
      expect((symbol = alphabet.predecessor(symbol)), 'G');
      expect((symbol = alphabet.predecessor(symbol)), 'F');
      expect((symbol = alphabet.predecessor(symbol)), 'E');
      expect((symbol = alphabet.predecessor(symbol)), 'D');
      expect((symbol = alphabet.predecessor(symbol)), 'C');
      expect((symbol = alphabet.predecessor(symbol)), 'B');
      expect((symbol = alphabet.predecessor(symbol)), 'A');
    });
  });
}
